<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<!-- Created by GNU Texinfo 5.2, http://www.gnu.org/software/texinfo/ -->
<head>
<title>bcron documentation</title>

<meta name="description" content="bcron documentation">
<meta name="keywords" content="bcron documentation">
<meta name="resource-type" content="document">
<meta name="distribution" content="global">
<meta name="Generator" content="makeinfo">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="#Top" rel="start" title="Top">
<link href="#SEC_Contents" rel="contents" title="Table of Contents">
<link href="dir.html#Top" rel="up" title="(dir)">
<style type="text/css">
<!--
a.summary-letter {text-decoration: none}
blockquote.smallquotation {font-size: smaller}
div.display {margin-left: 3.2em}
div.example {margin-left: 3.2em}
div.indentedblock {margin-left: 3.2em}
div.lisp {margin-left: 3.2em}
div.smalldisplay {margin-left: 3.2em}
div.smallexample {margin-left: 3.2em}
div.smallindentedblock {margin-left: 3.2em; font-size: smaller}
div.smalllisp {margin-left: 3.2em}
kbd {font-style:oblique}
pre.display {font-family: inherit}
pre.format {font-family: inherit}
pre.menu-comment {font-family: serif}
pre.menu-preformatted {font-family: serif}
pre.smalldisplay {font-family: inherit; font-size: smaller}
pre.smallexample {font-size: smaller}
pre.smallformat {font-family: inherit; font-size: smaller}
pre.smalllisp {font-size: smaller}
span.nocodebreak {white-space:nowrap}
span.nolinebreak {white-space:nowrap}
span.roman {font-family:serif; font-weight:normal}
span.sansserif {font-family:sans-serif; font-weight:normal}
ul.no-bullet {list-style: none}
-->
</style>


</head>

<body lang="en" bgcolor="#FFFFFF" text="#000000" link="#0000FF" vlink="#800080" alink="#FF0000">
<h1 class="settitle" align="center">bcron documentation</h1>




<a name="Top"></a>
<div class="header">
<p>
Next: <a href="#Introduction" accesskey="n" rel="next">Introduction</a>, Previous: <a href="dir.html#Top" accesskey="p" rel="prev">(dir)</a>, Up: <a href="dir.html#Top" accesskey="u" rel="up">(dir)</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<h1 class="node-heading">Top</h1>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Introduction" accesskey="1">Introduction</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Design-Notes" accesskey="2">Design Notes</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Configuration" accesskey="3">Configuration</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Implementation-Notes" accesskey="4">Implementation Notes</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Introduction"></a>
<div class="header">
<p>
Next: <a href="#Design-Notes" accesskey="n" rel="next">Design Notes</a>, Previous: <a href="#Top" accesskey="p" rel="prev">Top</a>, Up: <a href="#Top" accesskey="u" rel="up">Top</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Introduction-1"></a>
<h2 class="chapter">1 Introduction</h2>

<p>Name comes from: Bruce&rsquo;s / Better / Busy cron.
</p>
<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Problems" accesskey="1">Problems</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Requirements" accesskey="2">Requirements</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Design-Choices" accesskey="3">Design Choices</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#vixie_002dcron-Patches" accesskey="4">vixie-cron Patches</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Problems"></a>
<div class="header">
<p>
Next: <a href="#Requirements" accesskey="n" rel="next">Requirements</a>, Previous: <a href="#Introduction" accesskey="p" rel="prev">Introduction</a>, Up: <a href="#Introduction" accesskey="u" rel="up">Introduction</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Problems-With-Other-cron-Systems"></a>
<h3 class="section">1.1 Problems With Other cron Systems</h3>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Problems-with-vixie_002dcron" accesskey="1">Problems with vixie-cron</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Problems-with-fcron" accesskey="2">Problems with fcron</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Problems-with-anacron" accesskey="3">Problems with anacron</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Problems-with-dcron" accesskey="4">Problems with dcron</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Problems-with-vixie_002dcron"></a>
<div class="header">
<p>
Next: <a href="#Problems-with-fcron" accesskey="n" rel="next">Problems with fcron</a>, Previous: <a href="#Problems" accesskey="p" rel="prev">Problems</a>, Up: <a href="#Problems" accesskey="u" rel="up">Problems</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="vixie_002dcron"></a>
<h4 class="subsection">1.1.1 vixie-cron</h4>

<ul>
<li> Too many bugs
The last official release of vixie-cron was in December of 1993.
Since then, many security holes and other bugs have been found,
requiring every vendor to distribute a multiply-patched version of
this system.  Most vendors have a different set of patches, making
this a bit of a moving target.

</li><li> Can&rsquo;t handle DST changes
vixie-cron&rsquo;s mode of operations is to wake up every minute and
determine, with no history, what jobs to run.  When DST changes, this
causes some jobs to be either skipped or run twice.

</li></ul>

<hr>
<a name="Problems-with-fcron"></a>
<div class="header">
<p>
Next: <a href="#Problems-with-anacron" accesskey="n" rel="next">Problems with anacron</a>, Previous: <a href="#Problems-with-vixie_002dcron" accesskey="p" rel="prev">Problems with vixie-cron</a>, Up: <a href="#Problems" accesskey="u" rel="up">Problems</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="fcron"></a>
<h4 class="subsection">1.1.2 fcron</h4>

<ul>
<li> Parsing issues
If a job starts with a word (terminated by any non-word character,
like <code>/</code>) that happens to also be a username, fcron interprets
this word as the userid to run the job under, even for non-root users.
This causes problems for jobs like <code>bin/something</code> when user
<code>bin</code> exists.

</li><li> No support for <samp>/etc/cron.d</samp>

</li><li> No support for <samp>/etc/crontab</samp>

</li><li> Gratuitious incompatibilities with vixie-cron
Jobs are run with the login shell for the user instead of
<samp>/bin/sh</samp>.  The default mode of execution prevents the same job
from running multiple times (a good option, but bad default).
<code>MAILTO</code> can only contain a username, not a full email address.

</li></ul>

<hr>
<a name="Problems-with-anacron"></a>
<div class="header">
<p>
Next: <a href="#Problems-with-dcron" accesskey="n" rel="next">Problems with dcron</a>, Previous: <a href="#Problems-with-fcron" accesskey="p" rel="prev">Problems with fcron</a>, Up: <a href="#Problems" accesskey="u" rel="up">Problems</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="anacron"></a>
<h4 class="subsection">1.1.3 anacron</h4>

<p>Anacron is only really useful for running jobs once a day or less
frequently.  From what I&rsquo;ve seen, it&rsquo;s good at what it does, just not
useful at much else.
</p>
<hr>
<a name="Problems-with-dcron"></a>
<div class="header">
<p>
Previous: <a href="#Problems-with-anacron" accesskey="p" rel="prev">Problems with anacron</a>, Up: <a href="#Problems" accesskey="u" rel="up">Problems</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="dcron"></a>
<h4 class="subsection">1.1.4 dcron</h4>

<ul>
<li> No support for <samp>/etc/cron.d</samp>

</li><li> No support for <samp>/etc/crontab</samp>

</li><li> No easy way of emulating support for system crontabs
dcron&rsquo;s crontab format does not include a &ldquo;username&rdquo; column, and as
such makes it nearly impossible to even emulate system crontabs.

</li><li> Unusual or broken handling of DST changes
From reading the source, dcron only handles cases where the linear
time jumps.  When DST changes, linear time does not change, and so
dcron effectively does not handle this situation.

</li></ul>

<hr>
<a name="Requirements"></a>
<div class="header">
<p>
Next: <a href="#Design-Choices" accesskey="n" rel="next">Design Choices</a>, Previous: <a href="#Problems" accesskey="p" rel="prev">Problems</a>, Up: <a href="#Introduction" accesskey="u" rel="up">Introduction</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Requirements-1"></a>
<h3 class="section">1.2 Requirements</h3>

<ul>
<li> Security

<p>I am choosing to make a number of relatively unorthodox choices in
order to avoid many of the security issues that have plagued
vixie-cron and other related systems.
</p>
</li><li> External compatability with vixie-cron

<p>In particular, the system must support:
</p><ul>
<li> crontabs in the same file format as vixie-cron
</li><li> crontabs submitted via a command-line compatable <samp>crontab</samp>
program
</li><li> mail is sent to <code>$MAILTO</code> if the job produces any output
(and possibly if the job exits non-zero)
</li></ul>

</li><li> Support for system crontabs

<p>This means that the system MUST support:
</p><ul>
<li> System crontab entries in <samp>/etc/crontab</samp>
</li><li> System crontab entries in <samp>/etc/cron.d/*</samp>
</li></ul>
<p>System crontab entries are additionally differentiated from normal
ones by having a &ldquo;username&rdquo; column immediately preceding the
command.
</p>
</li><li> Intelligent handling of DST time changes

<p>One of the biggest frustrations I have had with dealing with
vixie-cron is its complete inability to deal with time jumps in an
intelligent manner.  In particular, when DST changes happen, jobs will
either get skipped (when time jumps forward) or executed twice (when
time jumps backwards).  This is unacceptable.
</p>
</li><li> Allow setting ulimits before executing commands

<p>In one of the target installations, we need to set up ulimits
(limiting CPU time and memory) before executing commands.  It would be
easy enough to ulimit the entire daemon, but then the daemon itself
would be vulnerable to getting killed when it has run for long enough.
Our current setup is to run jobs through a global wrapper script,
which can set any necessary limits (or anything else) and then execute
the job.
</p>
</li></ul>

<hr>
<a name="Design-Choices"></a>
<div class="header">
<p>
Next: <a href="#vixie_002dcron-Patches" accesskey="n" rel="next">vixie-cron Patches</a>, Previous: <a href="#Requirements" accesskey="p" rel="prev">Requirements</a>, Up: <a href="#Introduction" accesskey="u" rel="up">Introduction</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Design-Choices-1"></a>
<h3 class="section">1.3 Design Choices</h3>

<dl compact="compact">
<dt>Use local socket to submit files.</dt>
<dd>
<p>There are two basic methods of submitting crontab files:
</p><ol>
<li> Use a setuid program to write directly into spool files.
</li><li> Set up a local socket to submit jobs to a daemon.
</li></ol>
<p><a name="DOCF1" href="#FOOT1"><sup>1</sup></a> Using a setuid submission
agent was discarded to prevent the possibility of all the bugs that
have plagued other setuid submission agents.  The socket protocol is
deliberately very simple, to make the submission agent foolproof.
</p>
</dd>
<dt>Multiple process daemon.</dt>
<dd>
<p>By seperating job submission from job execution, exploiting the system
to run arbitrary jobs as privileged users is made even harder.  It
also makes the design of those individual programs much simpler.
</p>
</dd>
</dl>

<hr>
<a name="vixie_002dcron-Patches"></a>
<div class="header">
<p>
Previous: <a href="#Design-Choices" accesskey="p" rel="prev">Design Choices</a>, Up: <a href="#Introduction" accesskey="u" rel="up">Introduction</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="vixie_002dcron-Patches-1"></a>
<h3 class="section">1.4 vixie-cron Patches</h3>

<p>This section lists all the non-trivial patches found for vixie-cron,
what problem they appear to address, and (if appropriate) how bcron
will avoid the same problem.  The patches listed come from multiple
sources, including the latest RPM (Fedora Core IIRC).
</p>
<dl compact="compact">
<dt>0days.patch</dt>
<dd>
<p>This patch modifies the <samp>crontab.5</samp> man page to remove allowing
&lsquo;<samp>0</samp>&rsquo; for day of month or month numbers.
</p>
</dd>
<dt>badsig.patch</dt>
<dd>
<p>On some systems, signal handlers are single-shot.  This patch modifies
the SIGHUP handler to reactivate itself before it returns.  bcron will
use the bglibs signal functions, which use sigaction to create
suitable handlers, where appropriate.  bcron doesn&rsquo;t use signals for
any purpose.
</p>

</dd>
<dt>buffer.patch</dt>
<dd>
<p>This patch increases the maximum username length from 20 to 32, and
modifies calls to strcpy to use strncpy to ensure all string copies
are length bounded.  bcron uses dynamically allocated strings to
eliminate the possibility of buffer overflows.
</p>
</dd>
<dt>close_stdin.diff</dt>
<dd>
<p>This patch modifies the cron daemon to close stdin, stdout, and stderr
on startup, and to reopen them as <samp>/dev/null</samp>.  The bcron daemons
run under supervise, and have no need of such handling.
</p>
</dd>
<dt>crond.patch</dt>
<dd>
<p>Adds support for <samp>/etc/cron.d</samp>
</p>
</dd>
<dt>cront_stdin.patch</dt>
<dd>
<p>Appears to modify <samp>crontab</samp>&rsquo;s command-line handling such that no
argument is interpreted as to read the crontab from standard input.
</p>
</dd>
<dt>crontab.5.diff</dt>
<dd>
<p>Documents several builtin macros to replace the first 5 fields.  This
macros consist of: &lsquo;<samp>@reboot</samp>&rsquo;, &lsquo;<samp>@yearly</samp>&rsquo;,
&lsquo;<samp>@annually</samp>&rsquo;, &lsquo;<samp>@monthly</samp>&rsquo;, &lsquo;<samp>@weekly</samp>&rsquo;, &lsquo;<samp>@daily</samp>&rsquo;,
&lsquo;<samp>@midnight</samp>&rsquo;, and &lsquo;<samp>@hourly</samp>&rsquo;.  bcron will not, at least
initially, support these macros.
</p>
</dd>
<dt>crontab.patch</dt>
<dd>
<p>Modifies crontab to use strncpy and snprintf when writing into
length-bounded strings.
</p>
</dd>
<dt>crontabloc.patch</dt>
<dd>
<p>Patches the crontab man page to reference <samp>/etc/crontab</samp>.
</p>
</dd>
<dt>dst.patch</dt>
<dd>
<p>Patches the crontab man page to point out that DST may cause jobs to
be skipped or repeated.
</p>
</dd>
<dt>name.patch</dt>
<dd>
<p>Appears to modify how the cron daemon handles sending messages to
syslog.  bcron will log messages to stderr, avoiding syslog entirely.
</p>
</dd>
<dt>nodot.patch</dt>
<dd>
<p>Adds &lsquo;<samp>-i</samp>&rsquo; to the list of arguments sent to sendmail (result is
&lsquo;<samp>-FCronDaemon -i -odi -oem</samp>&rsquo;).  Only useful for sendmail, but
still needed.
</p>
</dd>
<dt>root_-u-85879.patch</dt>
<dd>
<p>Sanity checks the use of &lsquo;<samp>-u</samp>&rsquo; against UID and/or root.
</p>
</dd>
<dt>security2.patch</dt>
<dd>
<p>Does some sanity checking on mailto, and does a setuid before sending
mail.  bcron plays safe with mailto by putting it into a message
header, and always drops root privileges before executing commands.
</p>
</dd>
<dt>sigchld.patch</dt>
<dd>
<p>Return the SIGCHLD handler to its default state before executing
commands.
</p>
</dd>
<dt>sprintf.patch</dt>
<dd>
<p>More sprintf -&gt; snprintf conversions.
</p>
</dd>
<dt>time.patch</dt>
<dd>
<p>Sync all the crontabs before sleeping to handle changes in the system
time.
</p>
</dd>
<dt>timeaftertime.patch</dt>
<dd>
<p>The previous patch created double execution issues with small
backwards adjustments in the clock time.
</p>
</dd>
</dl>

<hr>
<a name="Design-Notes"></a>
<div class="header">
<p>
Next: <a href="#Configuration" accesskey="n" rel="next">Configuration</a>, Previous: <a href="#Introduction" accesskey="p" rel="prev">Introduction</a>, Up: <a href="#Top" accesskey="u" rel="up">Top</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Design-Notes-1"></a>
<h2 class="chapter">2 Design Notes</h2>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Fundamental-Operations" accesskey="1">Fundamental Operations</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Programs" accesskey="2">Programs</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Files" accesskey="3">Files</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#Inter_002dProcess-Communication" accesskey="4">Inter-Process Communication</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Fundamental-Operations"></a>
<div class="header">
<p>
Next: <a href="#Programs" accesskey="n" rel="next">Programs</a>, Previous: <a href="#Design-Notes" accesskey="p" rel="prev">Design Notes</a>, Up: <a href="#Design-Notes" accesskey="u" rel="up">Design Notes</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Fundamental-Operations-1"></a>
<h3 class="section">2.1 Fundamental Operations</h3>

<p>The following is a list of all the &ldquo;core&rdquo; operations that must be
provided based on the requirements.
</p>
<dl compact="compact">
<dt>Execute jobs</dt>
<dd><p>Strictly speaking, this is the only role that requires superuser
privileges.  Every other job should run as non-root.
</p>
</dd>
<dt>Schedule jobs</dt>
<dd><p>Scan all the known jobs, determine which one needs to be executed
next, and sleep until that time arrives.
</p>
</dd>
<dt>Accept new user crontabs</dt>
<dd><p>Listen for connections on a socket and accept job data.
</p>
</dd>
<dt>Parse crontabs into internal job format</dt>
<dd><p>Read the submitted files and parse their contents into a structured
format.
</p>
</dd>
<dt>Check for new system crontabs</dt>
<dd><p>Check <samp>/etc/crontab</samp> and <samp>/etc/cron.d/*</samp> every minute for
modifications.  If any files are changed, added, or deleted, add the
listed jobs.  On systems with tightened security, these files may only
be readable by &lsquo;<samp>root</samp>&rsquo;.
</p>
</dd>
<dt>Manage saved state</dt>
<dd><p>All jobs need to be saved to disk along with when they were last
executed, in order to determine when they should be next executed.
</p>
</dd>
</dl>

<hr>
<a name="Programs"></a>
<div class="header">
<p>
Next: <a href="#Files" accesskey="n" rel="next">Files</a>, Previous: <a href="#Fundamental-Operations" accesskey="p" rel="prev">Fundamental Operations</a>, Up: <a href="#Design-Notes" accesskey="u" rel="up">Design Notes</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Programs-1"></a>
<h3 class="section">2.2 Programs</h3>

<dl compact="compact">
<dt><samp>bcron-sched</samp></dt>
<dd><p>Top-level scheduler agent.  Starts up as root, runs <samp>bcron-exec</samp>,
and then drops root permanently.
</p>
</dd>
<dt><samp>bcron-exec</samp></dt>
<dd><p>Accepts jobs to run from <samp>bcron-sched</samp> on stdin, writes exit
status back to stdout.
</p>
</dd>
<dt><samp>bcron-spool</samp></dt>
<dd><p>Manages the cron spool: receives jobs submitted from users, writes
them to files in <samp>/var/spool/cron/crontabs</samp>, and notifies
<samp>bcron-sched</samp>.  This needs to be run from <samp>unixserver</samp> in
order to securely determine the invoking UID.  This program will
optionally run the file through an external filter, specified on the
command line, before installing the job.
</p>
</dd>
<dt><samp>bcron-update</samp></dt>
<dd><p>Watches for changes to the system crontabs and notifies
<samp>bcron-sched</samp>.
</p>
</dd>
</dl>

<hr>
<a name="Files"></a>
<div class="header">
<p>
Next: <a href="#Inter_002dProcess-Communication" accesskey="n" rel="next">Inter-Process Communication</a>, Previous: <a href="#Programs" accesskey="p" rel="prev">Programs</a>, Up: <a href="#Design-Notes" accesskey="u" rel="up">Design Notes</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Files-1"></a>
<h3 class="section">2.3 Files</h3>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#File-Hierarchy" accesskey="1">File Hierarchy</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="File-Hierarchy"></a>
<div class="header">
<p>
Previous: <a href="#Files" accesskey="p" rel="prev">Files</a>, Up: <a href="#Files" accesskey="u" rel="up">Files</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="File-Hierarchy-1"></a>
<h4 class="subsection">2.3.1 File Hierarchy</h4>

<dl compact="compact">
<dt><samp>/etc/cron.d/</samp></dt>
<dt><samp>/etc/cron.d/*</samp></dt>
<dt><samp>/etc/crontab</samp></dt>
<dd><p>The above three items are read
</p>
</dd>
<dt><samp>/var/spool/cron/</samp></dt>
<dt><samp>/var/spool/cron/crontabs/</samp></dt>
<dd><p>Directory containing raw (text) crontab files.
</p>
</dd>
<dt><samp>/var/spool/cron/crontabs/:etc:cron.d:*</samp></dt>
<dd><p>Colon is chosen as a seperator because usernames cannot contain
colons due to the format of <samp>/etc/passwd</samp>.
</p>
</dd>
<dt><samp>/var/spool/cron/crontabs/:etc:crontab</samp></dt>
<dt><samp>/var/spool/cron/bcrontabs/</samp></dt>
<dd><p>Directory containing pre-parsed (aka compiled) crontab files (Not yet
implemented).
</p>
</dd>
<dt><samp>/var/spool/cron/tmp/</samp></dt>
<dd><p>Temporary directory for files as they are written.
</p>
</dd>
<dt><samp>/var/spool/cron/trigger</samp></dt>
<dd><p>Named pipe used to tell <samp>bcron-sched</samp> to rescan the crontabs.
</p>
</dd>
</dl>


<hr>
<a name="Inter_002dProcess-Communication"></a>
<div class="header">
<p>
Previous: <a href="#Files" accesskey="p" rel="prev">Files</a>, Up: <a href="#Design-Notes" accesskey="u" rel="up">Design Notes</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Inter_002dProcess-Communication-1"></a>
<h3 class="section">2.4 Inter-Process Communication</h3>

<p>All communication between programs is done in terms of either
&ldquo;packets&rdquo; or &ldquo;lines&rdquo;.  A packet is formatted as a
<a href="http://cr.yp.to/proto/netstrings.txt">netstring</a>.  That is, a
packet of length <var>N</var> is encoded as the ASCII decimal value of
<var>N</var>, &lsquo;<samp>:</samp>&rsquo;, N bytes of data, terminated by &lsquo;<samp>,</samp>&rsquo;.  A line is
simply a series of non-NUL bytes terminated by a NUL byte.
</p>
<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Job-Submission-Protocol" accesskey="1">Job Submission Protocol</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
<tr><td align="left" valign="top">&bull; <a href="#bcron_002dexec-Protocol" accesskey="2">bcron-exec Protocol</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Job-Submission-Protocol"></a>
<div class="header">
<p>
Next: <a href="#bcron_002dexec-Protocol" accesskey="n" rel="next">bcron-exec Protocol</a>, Previous: <a href="#Inter_002dProcess-Communication" accesskey="p" rel="prev">Inter-Process Communication</a>, Up: <a href="#Inter_002dProcess-Communication" accesskey="u" rel="up">Inter-Process Communication</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Job-Submission-Protocol-1"></a>
<h4 class="subsection">2.4.1 Job Submission Protocol</h4>

<p>Client sends a packet containing a single byte command followed by the
username.  If the command requires additional data, it is seperated
from the username by a NUL byte.  Server responds with a packet
containing a response byte followed by a text message.
</p>
<p>Client command codes are:
</p><dl compact="compact">
<dt><code>S</code></dt>
<dd><p>Submit a user crontab file.  The content string contains the entire
crontab file.
</p></dd>
<dt><code>L</code></dt>
<dd><p>List the current crontab file.  No content string.
</p></dd>
<dt><code>R</code></dt>
<dd><p>Remove any previously submitted crontab file.  No content string.
</p></dd>
<dt><code>Y</code></dt>
<dd><p>List all system crontabs.  No content string.  This command is only
available to users &lsquo;<samp>root</samp>&rsquo; and &lsquo;<samp>cron</samp>&rsquo;.
</p></dd>
</dl>

<p>Server response codes are:
</p><dl compact="compact">
<dt><code>K</code></dt>
<dd><p>Command was successful; file was parsed and accepted.
</p></dd>
<dt><code>D</code></dt>
<dd><p>File could not be parsed.
</p></dd>
<dt><code>Z</code></dt>
<dd><p>Temporary internal error.
</p></dd>
</dl>

<hr>
<a name="bcron_002dexec-Protocol"></a>
<div class="header">
<p>
Previous: <a href="#Job-Submission-Protocol" accesskey="p" rel="prev">Job Submission Protocol</a>, Up: <a href="#Inter_002dProcess-Communication" accesskey="u" rel="up">Inter-Process Communication</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="bcron_002dexec-Protocol-1"></a>
<h4 class="subsection">2.4.2 bcron-exec Protocol</h4>

<p>Input packets contain a series of four or more NUL-terminated lines:
</p><dl compact="compact">
<dt><code>ID</code></dt>
<dt><code>username</code></dt>
<dt><code>command</code></dt>
<dt><code>environment</code></dt>
<dd><p>The environment is optional.  If the environment contains
<code>SHELL</code>, it replaces the default shell (&lsquo;<samp>/bin/sh</samp>&rsquo;).  If the
environment contains <code>MAILTO</code>, it overrides the default mailing
address derived from the username.
</p></dd>
</dl>

<p>Output packet:
</p><dl compact="compact">
<dt><code>ID</code></dt>
<dt><code>NUL</code></dt>
<dt><code>response code</code></dt>
<dt><code>text message</code></dt>
</dl>
<p>Output packets are sent asynchronously with respect to input packets.
</p>
<hr>
<a name="Configuration"></a>
<div class="header">
<p>
Next: <a href="#Implementation-Notes" accesskey="n" rel="next">Implementation Notes</a>, Previous: <a href="#Design-Notes" accesskey="p" rel="prev">Design Notes</a>, Up: <a href="#Top" accesskey="u" rel="up">Top</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Configuration-1"></a>
<h2 class="chapter">3 Configuration</h2>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Environment-Variables" accesskey="1">Environment Variables</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Environment-Variables"></a>
<div class="header">
<p>
Previous: <a href="#Configuration" accesskey="p" rel="prev">Configuration</a>, Up: <a href="#Configuration" accesskey="u" rel="up">Configuration</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Environment-Variables-1"></a>
<h3 class="section">3.1 Environment Variables</h3>

<dl compact="compact">
<dt><code>BCRON_SPOOL</code></dt>
<dd><p>The base directory for bcron&rsquo;s files.  Defaults to
<samp>/var/spool/cron</samp>.
</p>
</dd>
<dt><code>BCRON_USER</code></dt>
<dd><p>The non-root user name to switch to for all processes that don&rsquo;t
require root privileges.  Defaults to &lsquo;<samp>cron</samp>&rsquo;.
</p>
</dd>
<dt><code>BCRON_MAXSIZE</code></dt>
<dd><p>The maximum size (in bytes) of a single user crontab.  Defaults to
unlimited.
</p>
</dd>
<dt><code>BCRON_MAXJOBS</code></dt>
<dd><p>The maximum number of jobs in a single user crontab.  Defaults to
unlimited.
</p>
</dd>
<dt><code>BCRON_SOCKET</code></dt>
<dd><p>The full path to the UNIX-domain socket used to submit crontabs.
Defaults to <samp>/var/run/bcron-spool</samp>.
</p>
</dd>
</dl>

<hr>
<a name="Implementation-Notes"></a>
<div class="header">
<p>
Previous: <a href="#Configuration" accesskey="p" rel="prev">Configuration</a>, Up: <a href="#Top" accesskey="u" rel="up">Top</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Implementation-Notes-1"></a>
<h2 class="chapter">4 Implementation Notes</h2>

<table class="menu" border="0" cellspacing="0">
<tr><td align="left" valign="top">&bull; <a href="#Job-Scheduler" accesskey="1">Job Scheduler</a>:</td><td>&nbsp;&nbsp;</td><td align="left" valign="top">
</td></tr>
</table>

<hr>
<a name="Job-Scheduler"></a>
<div class="header">
<p>
Previous: <a href="#Implementation-Notes" accesskey="p" rel="prev">Implementation Notes</a>, Up: <a href="#Implementation-Notes" accesskey="u" rel="up">Implementation Notes</a> &nbsp; [<a href="#SEC_Contents" title="Table of contents" rel="contents">Contents</a>]</p>
</div>
<a name="Job-Scheduler-1"></a>
<h3 class="section">4.1 Job Scheduler</h3>

<p>Getting the job scheduler to work correctly for all possible cases
consumed more time than all the other parts of the program put
together, and this is <strong>all</strong> because of the problems that
daylight savings causes.
</p>
<p>The ultimate goal is this: given a linear timestamp, determine the
<strong>next</strong> linear timestamp after which a job must be run.
&ldquo;Linear time&rdquo; means the number of seconds since an epoch, in this
case the UNIX epoch, midnight GMT January 1st, 1970.  To contrast,
&ldquo;local time&rdquo; means the time in terms of years, months, days, hours,
minutes, and seconds in the current locale.
</p>
<p>The time specification for jobs is composed of a set of local time
bitmaps quantifying under what time conditions the job should run,
assuming the conditions are evaluated every minute.  The maximum
scheduling resolution is one minute.
</p>
<p>The effective algorithm is to step through every possible minute until
the local time matches all the conditions in the time specification.
This would result in an algorithm that could take up to 527,040-1
steps to complete, which is far too big a number to evaluate on every
job.  So, the algorithm optimizes away all impossible cases to make
much larger time jumps.  For example, if the job cannot be scheduled
on the current day, skip over the entire day instead of just the
current minute.
</p>
<p>There are two ways I approached this task.  First, do all calculations
in terms of local time, and return the linear time at the last step.
Second, do as many calculations as possible in terms of linear time,
which can be returned directly.  Both methods start with the same
input data: The current linear time, and a set of bitmasks
representing under what time conditions the job should run.
</p>
<p>The first method was the most straightforward to get mostly working,
until I started to consider the implications of DST.  During the
transition from normal time to DST, an hour is skipped.  This is no
big deal, as <code>mktime</code> will (or can be made to) compensate by
picking the next valid hour when presented with a &ldquo;missing&rdquo; hour.
On the other hand, there are many gotchas when dealing with the
duplicated hour.  For example, hourly jobs need to get scheduled on
both, but daily jobs on only one.
</p>
<p>The second method was harder to get working initially, as the math is
more complicated.  Despite doing many calculations in terms of linear
time, this method still needs to keep track of the local time, in
order to check against the bitmaps as well as to determine things like
when the next day or month should start.  This approach proved to be
much easier to work with, once the initial math was done, and easier
to make work correctly with regards to DST transitions.
</p>
<a name="SEC_Contents"></a>
<h2 class="contents-heading">Table of Contents</h2>

<div class="contents">
<ul class="no-bullet">
<li><a name="toc-Introduction-1" href="#Introduction">1 Introduction</a>
<ul class="no-bullet">
  <li><a name="toc-Problems-With-Other-cron-Systems" href="#Problems">1.1 Problems With Other cron Systems</a>
  <ul class="no-bullet">
    <li><a name="toc-vixie_002dcron" href="#Problems-with-vixie_002dcron">1.1.1 vixie-cron</a></li>
    <li><a name="toc-fcron" href="#Problems-with-fcron">1.1.2 fcron</a></li>
    <li><a name="toc-anacron" href="#Problems-with-anacron">1.1.3 anacron</a></li>
    <li><a name="toc-dcron" href="#Problems-with-dcron">1.1.4 dcron</a></li>
  </ul></li>
  <li><a name="toc-Requirements-1" href="#Requirements">1.2 Requirements</a></li>
  <li><a name="toc-Design-Choices-1" href="#Design-Choices">1.3 Design Choices</a></li>
  <li><a name="toc-vixie_002dcron-Patches-1" href="#vixie_002dcron-Patches">1.4 vixie-cron Patches</a></li>
</ul></li>
<li><a name="toc-Design-Notes-1" href="#Design-Notes">2 Design Notes</a>
<ul class="no-bullet">
  <li><a name="toc-Fundamental-Operations-1" href="#Fundamental-Operations">2.1 Fundamental Operations</a></li>
  <li><a name="toc-Programs-1" href="#Programs">2.2 Programs</a></li>
  <li><a name="toc-Files-1" href="#Files">2.3 Files</a>
  <ul class="no-bullet">
    <li><a name="toc-File-Hierarchy-1" href="#File-Hierarchy">2.3.1 File Hierarchy</a></li>
  </ul></li>
  <li><a name="toc-Inter_002dProcess-Communication-1" href="#Inter_002dProcess-Communication">2.4 Inter-Process Communication</a>
  <ul class="no-bullet">
    <li><a name="toc-Job-Submission-Protocol-1" href="#Job-Submission-Protocol">2.4.1 Job Submission Protocol</a></li>
    <li><a name="toc-bcron_002dexec-Protocol-1" href="#bcron_002dexec-Protocol">2.4.2 bcron-exec Protocol</a></li>
  </ul></li>
</ul></li>
<li><a name="toc-Configuration-1" href="#Configuration">3 Configuration</a>
<ul class="no-bullet">
  <li><a name="toc-Environment-Variables-1" href="#Environment-Variables">3.1 Environment Variables</a></li>
</ul></li>
<li><a name="toc-Implementation-Notes-1" href="#Implementation-Notes">4 Implementation Notes</a>
<ul class="no-bullet">
  <li><a name="toc-Job-Scheduler-1" href="#Job-Scheduler">4.1 Job Scheduler</a></li>
</ul></li>

</ul>
</div>


<div class="footnote">
<hr>
<h4 class="footnotes-heading">Footnotes</h4>

<h3><a name="FOOT1" href="#DOCF1">(1)</a></h3>
<p>There are actually others, but these two are the most simple
and portable of the choices.  See also
<a href="http://cr.yp.to/docs/secureipc.html">http://cr.yp.to/docs/secureipc.html</a></p>
</div>
<hr>



</body>
</html>
